/*  Student Name: Wade Tregaskis
    Student Number: 02557793 */

//  Copyright (c) 2006, Wade Tregaskis.  All rights reserved.
//  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
//    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
//    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
//    * Neither the name of Wade Tregaskis nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#ifndef IOUTILS_H
#define IOUTILS_H

// -INCLUDES-

#include <iostream>
#include <fstream>
#include "utils.h"
using namespace std;


// -DEFINES-

#define IOUTILS_VERSION 1.03
#define LINE_BUFFER_SIZE 251
#define MENU_ITEM_LIMIT 40


// -CLASSES-

class Menu {
public:
    Menu(const char *newTitle = NULL);

    void setTitle(const char *newTitle);
    const char* getTitle(void) const;

    void append(const char *newItem, int key);
    void appendBreak(void);

    int getSelection(void) const;
    void setSelection(int index);
    void clearSelection(void);
    const char* selectedName(void) const;
    int selectedKey(void) const;

    bool isFull(void) const;

    void displayNumeric(void);
    void displayAlphabetic(void);
private:
    const char *title;
    const char *item[MENU_ITEM_LIMIT];
    int selection, numberOfItems, itemKey[MENU_ITEM_LIMIT];
};

// -FUNCTIONS-

void displayRepeat(ostream& out, const char ch, int times);
void outputFixedLength(ostream& out, const char *data, const int maxLength, const bool left);
void safeGetline(istream& in, char *data, const int maxLength);
bool getBoolean(istream& in);
char getChar(istream& in);
bool switchIsInArguments(const int argc, const char **argv, const char sw);
int firstDataArgument(const int argc, const char **argv);
bool fileIsReadable(const char* name);

#endif
