/*  Student Name: Wade Tregaskis
    Student Number: 02557793 */

//  Copyright (c) 2006, Wade Tregaskis.  All rights reserved.
//  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
//    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
//    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
//    * Neither the name of Wade Tregaskis nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#ifndef SPECIES_H
#define SPECIES_H

// -INCLUDES-

#include <ctime>
#include <iostream>
#include <cctype>
#include <cstring>
#include "utils.h"
#include "ioutils.h"
#include "subjectlib.h"

#ifndef __APPLE__
#include <mcheck.h> // for generating trace logs
#endif

using namespace std;

// -DEFINES-

#define SUBJECT_VERSION 2.05
#define STRICT_PROPERTY_COUNT_LIMIT 10
#define BRIEF_LIST_THRESHOLD 10
#define VERBOSE_LIST_THRESHOLD 4
#define FILENAME_BUFFER_SIZE 255


// -FUNCTIONS-

void displayList(SubjectList *list);
void displayList(SubjectList *list, bool format);
void addSubjectToList(SubjectList *list);
void addSubjectToList(SubjectList *list, List<Question> *questions);
void searchList(SubjectList *list);

#endif
